using System.Collections.Generic;
using UnityEngine;

/// <summary>
/// 嶯еѭ͡
/// </summary>
public enum MyLoopType
{
    Once,       // һ
    Count,      // ָ
    Forever     // ѭ
}

/// <summary>
/// 嶯ѭ͡
/// </summary>
public enum GroupLoopType
{
    Once,        // ѭһκ
    Count,       // ѭָ
    Forever      // ѭ
}

/// <summary>
/// ʾһУһϵо顢ÿ֡ʾʱѭ͡
/// </summary>
[System.Serializable]
public class AnimationSequence
{
    [Tooltip("еľб")]
    public List<Sprite> sprites = new List<Sprite>();

    [Tooltip("ÿһ֡ʱ䣬λ")]
    public float frameTime = 0.1f; // ÿ֡ĳʱ䣨룩

    [Tooltip("еѭ")]
    public MyLoopType loopType = MyLoopType.Forever; // еѭ

    [Tooltip("еѭ LoopType Ϊ Count ʱЧ")]
    public int loopCount = 1; // еѭ
}

/// <summary>
/// ƾ鶯ŵ֧࣬ѭΪÿѭͺѭ
/// </summary>
public class SpriteAnimator : MonoBehaviour
{
    [Header("б")]
    [Tooltip("ж")]
    public List<AnimationSequence> animationSequences = new List<AnimationSequence>();

    [Header("SpriteRenderer")]
    [Tooltip("ʾSpriteRenderer")]
    public SpriteRenderer spriteRenderer;

    [Header("ѭ")]
    [Tooltip("ѡ񶯻ѭ")]
    public GroupLoopType groupLoopType = GroupLoopType.Forever;

    [Tooltip("ѭ GroupLoopType Ϊ Count ʱЧ")]
    public int groupLoopCount = 1;

    // ڲ
    private Dictionary<int, AnimationSequence> animationDictionary = new Dictionary<int, AnimationSequence>();
    private AnimationSequence currentAnimation;
    private int currentFrameIndex = 0;
    private float frameTimer = 0f;
    private bool isPlaying = true;
    private int currentAnimationIndex = 0; // ǰŵĶ
    private int currentGroupLoopIteration = 0; // ǰѭ
    private int currentSequenceLoopIteration = 0; // ǰѭ

    /// <summary>
    /// ʼ档
    /// </summary>
    private void Awake()
    {
        if (animationSequences == null || animationSequences.Count == 0)
        {
            Debug.LogError("бΪա Inspector ӶС");
            return;
        }

        for (int i = 0; i < animationSequences.Count; i++)
        {
            if (!animationDictionary.ContainsKey(i))
            {
                animationDictionary.Add(i, animationSequences[i]);
            }
            else
            {
                Debug.LogWarning($"ظĶ {i}ظ");
            }
        }

        SetAnimation(currentAnimationIndex);
    }

    /// <summary>
    /// ڿʼʱгʼ
    /// </summary>
    private void Start()
    {
        if (spriteRenderer == null)
        {
            Debug.LogError("SpriteRenderer 'spriteRenderer' Ϊա Inspector з SpriteRenderer");
            return;
        }

        if (currentAnimation != null && currentAnimation.sprites.Count > 0)
        {
            frameTimer = currentAnimation.frameTime;
            spriteRenderer.sprite = currentAnimation.sprites[currentFrameIndex];
        }
        else
        {
            Debug.LogError("ǰΪջ򲻰顣");
        }
    }

    /// <summary>
    /// ÿ֡¶š
    /// </summary>
    private void Update()
    {
        if (!isPlaying || currentAnimation == null || currentAnimation.sprites.Count == 0)
            return;

        // ֡ʱ
        frameTimer -= Time.deltaTime;

        if (frameTimer <= 0f)
        {
            AdvanceFrame();

            // ȡǰеѭ
            MyLoopType currentLoopType = currentAnimation.loopType;

            switch (currentLoopType)
            {
                case MyLoopType.Once:
                    if (currentFrameIndex == currentAnimation.sprites.Count - 1)
                    {
                        MoveToNextSequence();
                    }
                    break;

                case MyLoopType.Count:
                    if (currentFrameIndex == currentAnimation.sprites.Count - 1)
                    {
                        currentSequenceLoopIteration++;
                        if (currentSequenceLoopIteration >= currentAnimation.loopCount)
                        {
                            MoveToNextSequence();
                        }
                        else
                        {
                            ResetCurrentSequence();
                        }
                    }
                    break;

                case MyLoopType.Forever:
                    // ⴦ѭ
                    break;
            }

            frameTimer = currentAnimation.frameTime;
        }
    }

    /// <summary>
    /// õǰŵĶС
    /// </summary>
    /// <param name="index"></param>
    public void SetAnimation(int index)
    {
        if (animationDictionary.TryGetValue(index, out AnimationSequence selectedAnimation))
        {
            currentAnimation = selectedAnimation;
            currentFrameIndex = 0;
            frameTimer = currentAnimation.frameTime;
            currentSequenceLoopIteration = 0;

            if (currentAnimation.sprites.Count > 0)
            {
                spriteRenderer.sprite = currentAnimation.sprites[currentFrameIndex];
            }
            else
            {
                Debug.LogWarning($"ѡеĶ {index} ûаκξ顣");
            }
        }
        else
        {
            Debug.LogError($"SetAnimation:  {index}  animationDictionary δҵ");
        }
    }

    /// <summary>
    /// ƶĲźͣ
    /// </summary>
    /// <param name="play">true: Ŷ, false: ͣ</param>
    public void PlayPauseAnimation(bool play)
    {
        isPlaying = play;
        if (isPlaying && currentAnimation != null && currentAnimation.sprites.Count > 0)
        {
            // ȷǰ֡ʾȷ
            spriteRenderer.sprite = currentAnimation.sprites[currentFrameIndex];
            frameTimer = currentAnimation.frameTime;
            //  currentSequenceLoopIterationӰѭ
        }
    }

    /// <summary>
    /// ǰһ֡SpriteRendererľ顣
    /// </summary>
    private void AdvanceFrame()
    {
        if (currentAnimation.sprites.Count == 0)
            return;

        currentFrameIndex++;

        if (currentFrameIndex >= currentAnimation.sprites.Count)
        {
            currentFrameIndex = currentAnimation.sprites.Count - 1;
        }

        spriteRenderer.sprite = currentAnimation.sprites[currentFrameIndex];
    }

    /// <summary>
    /// õǰеĲ״̬Աѭ
    /// </summary>
    private void ResetCurrentSequence()
    {
        currentFrameIndex = 0;
        frameTimer = currentAnimation.frameTime;
        spriteRenderer.sprite = currentAnimation.sprites[currentFrameIndex];
    }

    /// <summary>
    /// лһУѭ;Ƿѭٶ顣
    /// </summary>
    private void MoveToNextSequence()
    {
        currentAnimationIndex++;

        if (currentAnimationIndex >= animationSequences.Count)
        {
            // һ鶯
            currentAnimationIndex = 0;
            currentGroupLoopIteration++;

            switch (groupLoopType)
            {
                case GroupLoopType.Once:
                    isPlaying = false;
                    Destroy(gameObject); // ٶ
                    return;

                case GroupLoopType.Count:
                    if (currentGroupLoopIteration >= groupLoopCount)
                    {
                        isPlaying = false;
                        Destroy(gameObject); // ٶ
                        return;
                    }
                    break;

                case GroupLoopType.Forever:
                    // ѭ
                    break;
            }
        }

        SetAnimation(currentAnimationIndex);
    }

    /// <summary>
    /// ٶʱ档
    /// </summary>
    private void OnDestroy()
    {
        animationDictionary.Clear();
        animationSequences = null;
        currentAnimation = null;
    }
}
