using System.Collections;
using System.Collections.Generic;
using System.Threading.Tasks;
using Unity.VisualScripting;
using UnityEngine;
using UnityEngine.UIElements;
using System.Linq;

public enum BulletType
{
    Bullet,
    Lightning,
    Spraying,  //ԭ
    XuLi //
}
public enum BulletAttributes
{
    Not,
    Gold,//ľˮ
    Wood,
    Water,
    Fire,
    Earth
}



public enum BulletMoveType
{/// <summary>
/// ӵƶʽ:Ե,
/// </summary>
    PeerToPeer,
    /// <summary>
    /// ƶ
    /// </summary>
    PointToDirection,
    Scope
}


public class BulletData
{
    [Header("ӵ͸")] public int NumberOfBulletPenetrations = 1;
    /// <summary>
    /// ӵɢ
    /// </summary>
    [Header("ӵɢ")] public int BulletScattering = 1;
    [Header("ӵ")] public int BulletBurstTimes = 1;
    [Header("ӵ")] public float BulletBurstInterval ;
    [Header("ӵ͸˥")] public float BulletPenetrationAttenuation = 0.2f;
    [Header("ӵٶ")] public float BulletSpeed = 5f;
    [Header("ӵȴ")] public float BulletAttackCooldown = 1f;
    [Header("ӵ˺")] public float attack = 10;
    
    public BulletData()
    {

    }
    public BulletData(int numberOfBulletPenetrations, int bulletScattering, int bulletBurstTimes, float bulletBurstInterval, float bulletPenetrationAttenuation, float bulletSpeed, float bulletAttackCooldown)
    {
        NumberOfBulletPenetrations = numberOfBulletPenetrations;
        BulletScattering = bulletScattering;
        BulletBurstTimes = bulletBurstTimes;
        BulletBurstInterval = bulletBurstInterval;
        BulletPenetrationAttenuation = bulletPenetrationAttenuation;
        BulletSpeed = bulletSpeed;
        BulletAttackCooldown = bulletAttackCooldown;
    }

    public override string ToString()
    {
        return
            $"{nameof(NumberOfBulletPenetrations)}: {NumberOfBulletPenetrations}, {nameof(BulletScattering)}: {BulletScattering}, {nameof(BulletBurstTimes)}: {BulletBurstTimes}, {nameof(BulletBurstInterval)}: {BulletBurstInterval}, {nameof(BulletPenetrationAttenuation)}: {BulletPenetrationAttenuation}, {nameof(BulletSpeed)}: {BulletSpeed}, {nameof(BulletAttackCooldown)}: {BulletAttackCooldown}";
    }
}
public class Bullet : MonoBehaviour
{
    [Header("ӵɫ")] public Role role;
    [Header("ӵ䷶Χ")] public Attack attackObj;
    [Header("ӵ")] public BulletType myBulletType;
    [Header("ӵ")] public BulletAttributes bulletAttributes;
    [Header("")] public BulletMoveType bulletMoveType;
    [Header("ӵ")] public BulletData bulletData = new BulletData();
    [Header("ʱ,Ĭ10f")] public float BulletDeadTimer = 10f;
    [Header("ӵ")] public Animator animator;
    [Header("ӵƶ")] public bool IsMove = true;
    [Header("ӵײ")] public CircleCollider2D Collider2D;
    [Header("ӵЧԤ")] public List<GameObject> effectPres = new List<GameObject>();
    public float timer = 0;
    [Header("ӵ")] public int NumberOfBulletAttacks = 1;
    [Header("Ŀ")] public GameObject Target;
    [Header("ӵǷĿ")] public bool noLockEnemy=false;
    [Header("ӵǷ")] public bool Cansplit = false;
    [Header("ӵԤ")] public GameObject smallBulletPrefab;
    [Header("ӵǷᱬը")] public bool CanBoom = false;
    private void Update()
    {
        switch (this.bulletMoveType)
        {
            //ӵƶʽƶ
            case BulletMoveType.PeerToPeer:
                if (IsMove)
                {
                    
                    if (Target != null&&Target.activeSelf==true&&!noLockEnemy)
                    {
                        this.gameObject.transform.position = Vector3.MoveTowards(this.gameObject.transform.position, Target.transform.position, Time.deltaTime * bulletData.BulletSpeed);
                    }
                    else
                    {
                        this.gameObject.transform.Translate(Vector3.up * Time.deltaTime * bulletData.BulletSpeed);
                    }


                    timer += Time.deltaTime;
                    if (timer > BulletDeadTimer)
                    {
                        attackObj.bulltes.Remove(this.gameObject);
                        Debug.Log("ѳɹƳǰб" + attackObj.bulltes.Count);
                        Destroy(this.gameObject);
                    }
                }
               
                break;
            case BulletMoveType.PointToDirection:
                break;
            case BulletMoveType.Scope:
                break;
        }

      

    }
   
    private void OnTriggerEnter2D(Collider2D collision)
    {
        Role Crole = collision.gameObject.GetComponent<Role>();
        if (Crole)
        {
            if (Crole.camp != role.camp)
            {
                if (NumberOfBulletAttacks < 0)
                {
                    return;
                }
                else
                {
                    if (this.myBulletType== BulletType.Spraying)
                    {
                        NumberOfBulletAttacks += 1;
                    }

                    NumberOfBulletAttacks -= 1;

                    foreach (var buff in role.storageBuff)
                    {
                        if (!Crole.PlayerBuff.Contains(buff))
                        {
                            Crole.PlayerBuff.Add(buff);
                        }
                    }

                    Crole.ApplyBuffs();

                   // Debug.Log(this.role.gameObject.name + "й");
                    int direction = 0;
                    if (collision.transform.position.x > transform.position.x) //ӵ򵽵ߣƮʾұ
                    {
                        direction = 1;
                    }
                    if (!CanBoom)//жӵǷᱬը
                    {
                        Crole.bloodLoss(new object[] { Crole, role.DamageCreate(Crole.GetComponent<Role>()), attackObj.damageTyp, role }, direction);
                        attackObj.bulltes.Remove(this.gameObject);
                        if (myBulletType != BulletType.Spraying)
                        {


                            if (animator == null)
                            {
                                SplitBullet();
                                attackObj.bulltes.Remove(this.gameObject);
                                Destroy(this.gameObject);
                            }
                            else
                            {
                                IsMove = false; //ֹͣƶ
                                Collider2D.enabled = false; //رײ
                                transform.position = collision.transform.position;
                                animator.SetTrigger("Boom");

                            }
                        }
                    }
                    else
                    {
                        if (animator!=null)
                        {
                            IsMove = false; //ֹͣƶ
                            Collider2D.enabled = false; //رײ
                            transform.position = collision.transform.position;
                            animator.SetTrigger("Boom");
                        }
                    }
                    

                    

                    if (bulletAttributes == BulletAttributes.Not) //
                    {
                        Crole.FlashRedEffect();

                    }

                    if (bulletAttributes == BulletAttributes.Fire) //
                    {

                        if (effectPres.Count == 1)
                        {
                            GameObject go = Instantiate(effectPres[0], collision.transform);
                            go.transform.position = new Vector2(collision.transform.position.x,
                                collision.transform.position.y + 0.2f);
                            go.GetComponent<Huo>().bullet = this;
                            Crole.FlashRedEffect();
                            //Debug.Log("");
                        }

                    }

                    if (bulletAttributes == BulletAttributes.Water) //ˮ
                    {
                        if (effectPres.Count > 1)
                        {
                            GameObject go = Instantiate(effectPres[Random.Range(0, effectPres.Count - 1)],
                                collision.transform);
                            go.transform.position = new Vector2(collision.transform.position.x,
                                collision.transform.position.y - 0.2f);
                            collision.transform.GetComponent<enemy>().SlowDown(0.2f, 3f);
                            Crole.FlashRedEffect(1, 3f);

                        }

                    }


                }
            }
        }
    }
    private float lastDamageTime = 0f;
    private void OnTriggerStay2D(Collider2D collision)
    {
        Role Crole = collision.gameObject.GetComponent<Role>();
        if (Crole)
        {
            if (Crole.camp != role.camp)
            {


                int direction = 0;
                if (collision.transform.position.x >= transform.position.x)//ӵ򵽵ߣƮʾұ
                {
                    direction = 1;
                }

                if (myBulletType == BulletType.Spraying)
                {
                    
                    if (Time.time - lastDamageTime > 1f) // ÿһѪ
                    {
                     
                        Crole.bloodLoss(new object[] { Crole, role.DamageCreate( Crole.GetComponent<Role>()), attackObj.damageTyp, role });
                        Crole.FlashRedEffect();
                        lastDamageTime = Time.time;
                    }
                  
                    
                }
            }
        }
    }

    public void DesBullet()
    {
        attackObj.bulltes.Remove(this.gameObject);
        Destroy(this.gameObject);
    }


    private void OnTriggerExit2D(Collider2D collision)
    {
        //Debug.Log("ⷶΧ");
        Role Crole = collision.gameObject.GetComponent<Role>();
        if (Crole)
        {
            if (Crole.camp != role.camp)
            {               
               
                //Debug.Log("ѳɹƳǰб" + attackObj.bulltes.Count);
                if (myBulletType != BulletType.Spraying)
                {
                    if (animator==null)
                    {
                        attackObj.bulltes.Remove(this.gameObject);
                        Destroy(this.gameObject);
                    }
                }

            }
        }
    }

    public void SplitBullet()//ӵ
    {
        if (Cansplit)
        {
            // ȡǰӵǰ
            Vector3 currentDirection = transform.forward;

            // ɵСӵ
            for (int i = 0; i < attackObj.splitNum; i++)
            {
                // ڵǰƫ
                Vector3 randomOffset = new Vector3(Random.Range(-0.2f, 0.2f), Random.Range(-0.2f, 0.2f));

                // һСӵ
                GameObject smallBullet = Instantiate(smallBulletPrefab, transform.position, Quaternion.identity);
                smallBullet.GetComponent<SmallBullet>().role = role;
                smallBullet.GetComponent<SmallBullet>().attackObj=attackObj;
                smallBullet.GetComponent<SmallBullet>().Target = Target;
                // ΪСӵ÷з򣨵ǰ + ƫƣ
                smallBullet.transform.up = currentDirection+randomOffset;

                // Сӵ߼繥ԡڵ
            }
        }
    }

    public void BulletBoom()  // ӵը
    {


        // չײĴСģⱬըΧ
        float explosionRadius = attackObj.BoomRange;  // ñըİ뾶С

        

        // ⱬըΧڵĵ
        Collider2D[] hitEnemies = Physics2D.OverlapCircleAll(transform.position, explosionRadius);

        foreach (var enemyCollider in hitEnemies)
        {
            Role enemyRole = enemyCollider.gameObject.GetComponent<Role>();
            if (enemyRole != null && enemyRole.camp != role.camp)  // ǵ˲ڲͬӪ
            {
                // ˺ֵԸӵͻ
                float damage = role.DamageCreate(enemyRole);

                // Ѫ
                enemyRole.bloodLoss(new object[] { enemyRole, damage, attackObj.damageTyp, role });

                enemyRole.FlashRedEffect();
            }
        }


        // ٵǰӵ
        attackObj.bulltes.Remove(this.gameObject);
        Destroy(this.gameObject);
    }

    void OnDestroy()
    {

        // ֹͣЭ
        StopAllCoroutines();


        // δʹõԴ
        Resources.UnloadUnusedAssets();
    }
}
