using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Networking;
using System.Threading.Tasks;
using System;


public class ImageLoader : MonoBehaviour
{
    // ֵ
    private Dictionary<string, Sprite> imageCache = new Dictionary<string, Sprite>();
    public Sprite sprite;
    // 첽ͼƬ
    public async Task<Sprite> LoadImageAsync(string url)
    {
        if (!IsValidUrl(url))
        {
            return sprite;
        }
        // ѾͼƬֱӷػͼƬ
        if (imageCache.ContainsKey(url))
        {
            return imageCache[url];
        }

        // ûͼƬ첽
        using (UnityWebRequest webRequest = UnityWebRequestTexture.GetTexture(url))
        {
            // 󲢵ȴӦ
            var operation = webRequest.SendWebRequest();
            while (!operation.isDone)
                await Task.Yield(); // ȴɣʹawaitԷķʽ
            // Ƿɹ
            if (webRequest.result == UnityWebRequest.Result.Success)
            {
                // ȡص
                Texture2D texture = ((DownloadHandlerTexture)webRequest.downloadHandler).texture;

                // 
                imageCache[url] = TextureToSprite(texture);
                return imageCache[url];
            }
            else
            {
                //Debug.LogError("Failed to load image: " + webRequest.error);
                return sprite;
            }
        }
    }
    // Texture2DתΪSprite
    Sprite TextureToSprite(Texture2D texture)
    {
        // ʹĳߴ紴һSprite
        return Sprite.Create(texture, new Rect(0, 0, texture.width, texture.height), new Vector2(0.5f, 0.5f));
    }

    public static bool IsValidUrl(string url)
    {
        Uri uriResult;
        return Uri.TryCreate(url, UriKind.Absolute, out uriResult) && (uriResult.Scheme == Uri.UriSchemeHttp || uriResult.Scheme == Uri.UriSchemeHttps);
    }
}
